﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
'ASViewPager
'Author: Alexander Stolte
'Version: V1.19
#If Documentation
Changelog:
V1.00
	-Release
V1.01
	-Base_Resize is now public
	-NextPage and PreviousPage Bug Fix
	-setCurrentIndex Bug Fix
	-PageChangedEvent Bug Fix
V1.02
	-B4I Bug Fixes
	-NextPage and PreviousPage Bug Fix
V1.03
	-Resize BugFix
V1.04
	-B4I Page-Height BugFix
	-B4I Page-Swipe BugFix
V1.05
	-BugFix
V1.06
	-Add Designer Property "Orientation" - Vertical is now supported
V1.07
	-BugFix getCurrentIndex
	-BugFix PageChanged event is now only firing if the index is changed
	-Add setIgnorePageChangedEvent Property
	-Add TouchBegin Event
	-Add TouchEnd Event
	-BugFix PageChanged is now firing if you press on a emulator, for example the arrow up or down keys on yor keyboard
V1.08
	-Add Tag Property 
		https://www.b4x.com/android/forum/threads/b4x-how-to-get-custom-view-here-from-clv-or-any-other-container.117992/#content
	-Add Clear - clears the list and sets the index to 0
	-BugFix xCustomListview Top was always 0
V1.09
	-B4I BugFixes for Release Mode - swiping is now better
V1.10
	-Add AddPageAt (experimental it works for my need, if you have issuses, then tell me) - Adds an page at a special position
	-Add set CurrentIndex2 - sets the current index - jumps to the item
	-Better resize handling
V1.11
	-RemovePage Bugfixes
	-B4J ScrollPane under the hood is now Transparent
	-Add NextPage2 -Jump to next page
	-Add PrevoiusPage2 - Jump to previous page
V1.12
	-[BETA] Add DesignerProperty Carousel - infinite swipe
		-On B4I Bounce Effect is disabled
	-B4I ScrollView Paging is now activated, this can improve the handling
V1.13
	-Add PageClick Event
V1.14
	-B4I only Add Scroll - enable or disable scroll with finger
V1.15
	-Intern Function IIF renamed to iif2
V1.16
	-set Scroll is now B4X - disable the swipe/scroll
		-In B4J the arrow keys (Left/Right/Up/Down) are disabled if you deactivate the swipe/scroll
	-New property isScrollEnabled - checks if the swipe/scroll is enabled or disabled
	-Intern Function iif2 removed and the core iif is now used
		-B4A V9.10+ - B4J V9.10+ - B4I V7.50+
V1.18
	-PageChanged Event is now firing in some cases with a delay, because of a scroll animation
	-BugFix B4A setScroll - Events from other views are now no longer blocked
V1.19
	-BugFix on NextPage and PreviousPage
V1.20
	-Add Event PageChange - This event is triggered immediately after the page is changed, no delay because of animations
	-Add setIgnorePageChangeEvent - prevents the PageChange event from being triggered
V1.21
	-BugFixing
V1.22
	-B4I Scroll = False BugFix
V1.24
	-BugFix AddPageAt is now working better on B4A
V1.25
	-Add Scroll2Value - sets the current index by the value - smooth scrolls to the item
		-from the AddPage and AddPageAt function the "Value" property
		-must be a string to be found
	-Add Scroll2Value2 - sets the current index by the value - jump to the item
V1.26
	-Add Designer Property LazyLoading - activates lazy loading
		-Default: False
	-Add Designer Property LazyLoadingExtraSize - How many pages to load in advance
		-Default: 5
	-Add Event LazyLoadingAddContent - Add here your layout or views
V1.27
	-Add get and set LazyLoadingExtraSize
V1.28
	-Important LazyLoading improvments
V1.29
	-Add Commit - Triggers the LazyLoadingAddContent event
		-Call this after you have filled the list
	-LazyLoading BugFixes
V1.30
	-Add ResetLazyloadingIndex - when you call "commit" afterwards, it is guaranteed to check if there are empty panels in the lazy loading range, if so, the LazyLoading event is triggered
V1.31
	-important resize improvments
	-Add Loading Panel if Base_Resize is calling
	-Add Designer Property LoadingPanelColor
	-Add set IgnoreLazyLoading - If True, the Lazy Loading event is not triggered
	-Add ResetLazyLoadingPanels - Removes all child views from all visible pages
	-LazyLoading Improvments
V1.32
	-Carousel works now in Vertical mode
V1.33
	-B4I Native paging is now used
		-The paging feels smoother now
		-In debug mode, the swiping should now also run better
V1.34
	-B4I The GestureRecognizer is no longer needed
V1.35
	-Add Designer Proeprty BackGestureGap - Only for B4I. If you use the ViewPager on a 2nd page and still want to close the page with the swipe gesture then set the checkbox to true
		-Default: False

-Add SwipeOnEndOfPage Event - triggers when the user scrolls even though he is already at the end of the list. Or if the user is on the 1st page and scrolls to the wrong direction
#End If

#DesignerProperty: Key: Orientation, DisplayName: Orientation, FieldType: String, DefaultValue: Horizontal, List: Horizontal|Vertical
#DesignerProperty: Key: Carousel, DisplayName: Carousel, FieldType: Boolean, DefaultValue: False, Description: infinite swipe
#DesignerProperty: Key: LazyLoading, DisplayName: Lazy Loading, FieldType: Boolean, DefaultValue: False, Description: activates lazy loading
#DesignerProperty: Key: LazyLoadingExtraSize, DisplayName: Lazy Loading Extra Size, FieldType: Int, DefaultValue: 5, MinRange: 0
#DesignerProperty: Key: LoadingPanelColor, DisplayName: Loading Panel Color, FieldType: Color, DefaultValue: 0xFF000000, Description: The color of the Loading panel if Base_Resize is executed
#DesignerProperty: Key: BackGestureGap, DisplayName: BackGestureGap, FieldType: Boolean, DefaultValue: False, Description: Only for B4I. If you use the ViewPager on a 2nd page and still want to close the page with the swipe gesture then set the checkbox to true

#Event: PageChange(Index as int)
#Event: PageChanged(Index as int)
#Event: ScrollChanged(Offset As Int)
#Event: ReachEnd
#Event: TouchBegin
#Event: TouchEnd
#Event: PageClick (Index As Int, Value As Object)
#Event: LazyLoadingAddContent(Parent As B4XView, Value As Object)
'#Event: SwipeOnEndOfPage

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	'Private tmr_main As Timer

	'Views
	Private xclv_main As CustomListView
	Private xpnl_Loading As B4XView
	
	'Variables etc...
	Private current_index As Int = 0'ignore
	Private lazyloading_index As Int = -1'ignore
	#If B4A or B4I
	Private g_x,g_y,g_dv,g_ad As Float
	Private g_ms As Long
	Private  isfirstmove As Boolean = False
	#end if
	#If B4I 
	Private xpnl_BackGestureGap As B4XView
	Private nome As NativeObject=Me
	'Private tmp As GestureRecognizer 
	Private m_Ignore As Boolean = False
	Private mView As View
	#end if
	Private g_ignorepagechangedevent As Boolean = False
	Private g_ignorepagechangeevent As Boolean = False
	Private g_orientation As String 
	Private g_Carousel As Boolean
	Private m_LazyLoading As Boolean
	Private m_LazyLoadingExtraSize As Int
	Private m_LoadingPanelColor As Int
	Private m_BackGestureGap As Boolean
	
	Private ismoving As Boolean = False
	Private g_isScrollEnabled As Boolean = True
	Private m_IgnoreLazyLoading As Boolean = False

	Public Tag As Object
	Private isLazyLoadingReady As Boolean = False
	Private isHidding As Boolean = False
	'Private SwipeOnEndOfPage_OnlyOnce As Boolean = True
	#If B4A
	Public OversizeMode As Boolean = False
	#End If
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	
	xpnl_Loading = xui.CreatePanel("")
	mBase.AddView(xpnl_Loading,0,0,mBase.Width,mBase.Height)
	xpnl_Loading.Color = xui.Color_Black
	xpnl_Loading.BringToFront
	
	g_orientation = Props.GetDefault("Orientation","Horizontal")
	g_Carousel = Props.GetDefault("Carousel",False)
	m_LazyLoading = Props.GetDefault("LazyLoading",False)
	m_LazyLoadingExtraSize = Props.GetDefault("LazyLoadingExtraSize",5)
	m_LoadingPanelColor = xui.PaintOrColorToColor(Props.GetDefault("LoadingPanelColor",xui.Color_Black))
	xpnl_Loading.Color = m_LoadingPanelColor
	m_BackGestureGap = Props.GetDefault("BackGestureGap",False)
	
	If xclv_main.IsInitialized = False Then
		ini_xclv
	End If
	
	#If B4A
	Base_Resize(mBase.Width,mBase.Height)
	#Else IF B4I
	Dim sv As ScrollView = xclv_main.sv
	If g_Carousel = True Then
		sv.Bounces = False
	End If
	sv.PagingEnabled = True
	
	xpnl_BackGestureGap = xui.CreatePanel("")
	xpnl_BackGestureGap.Color = xui.Color_Transparent
	If m_BackGestureGap Then mBase.AddView(xpnl_BackGestureGap,0,0,30dip,mBase.Height)
	#End If
	
End Sub

Private Sub ini_xclv
	Dim tmplbl As Label
	tmplbl.Initialize("")
 
	Dim tmpmap As Map
	tmpmap.Initialize
	tmpmap.Put("DividerColor",0x00FFFFFF)
	tmpmap.Put("DividerHeight",0)
	tmpmap.Put("PressedColor",0x00FFFFFF)
	tmpmap.Put("InsertAnimationDuration",0)
	tmpmap.Put("ListOrientation",g_orientation)
	tmpmap.Put("ShowScrollBar",False)
	xclv_main.Initialize(Me,"xclv_main")
	xclv_main.DesignerCreateView(mBase,tmplbl,tmpmap)
	#IF B4A
	Private objPages As Reflector
	objPages.Target = xclv_main.sv
	objPages.SetOnTouchListener("xpnl_PageArea2_Touch")
	#Else IF B4I	
	
	mView=xclv_main.GetBase
	nome.RunMethod("grLongPress::::",Array(0,1,0,mView))
	nome.RunMethod("grPan:::",Array(mView,1,1))
	
	'tmp.Initialize("tmp",Me,xclv_main.GetBase)'.sv)
	'tmp.AddLongPressGesture(0,1,0)
	'tmp.AddPanGesture(1,1)
	#Else IF B4J
	Dim r As Reflector
	r.Target = xclv_main.sv
	r.AddEventFilter("et", "javafx.scene.input.KeyEvent.KEY_PRESSED")
	r.AddEventFilter("et", "javafx.scene.input.KeyEvent.KEY_RELEASED")
'	r.AddEventFilter("RPScroll", "javafx.scene.input.ScrollEvent.SCROLL")
	Dim sp As ScrollPane = xclv_main.sv
	sp.Style="-fx-background:transparent;-fx-background-color:transparent;"
	
	Private jo = xclv_main.sv As JavaObject
	jo.RunMethod("setMouseTransparent", Array As Object(True))
	
	#End if
	
	#If B4I
	Do While xclv_main.sv.IsInitialized = False
		'Sleep(0)
	Loop
	Dim sv As ScrollView = xclv_main.sv
	sv.Color = xui.Color_Transparent'xui.Color_ARGB(255,32, 33, 37)
	#End If
	
End Sub

Public Sub Base_Resize (Width As Double, Height As Double)
	#IF B4I
	m_Ignore = True
	#End if
	#If B4J
	xpnl_Loading.BringToFront
	xpnl_Loading.SetLayoutAnimated(0,0,0,Width + 1000dip,Height + 1000dip)
	xpnl_Loading.SetVisibleAnimated(0,True)
	
	mBase.Width = Width
	mBase.Height = Height
	Sleep(0)
	xclv_main.AsView.SetLayoutAnimated(0,xclv_main.AsView.Left,xclv_main.AsView.Top,mBase.Width,mBase.Height)
	xclv_main.Base_Resize(mBase.Width,mBase.Height)
		
		For i = 0 To xclv_main.Size -1
			If g_orientation = "Horizontal" Then
			xclv_main.ResizeItem(i,mBase.Width)
			Else
			xclv_main.ResizeItem(i,mBase.Height)
			End If	
		xpnl_Loading.SetVisibleAnimated(0,True)
		Next
	xpnl_Loading.SetVisibleAnimated(0,True)

	Sleep(0)

	xclv_main.JumpToItem(current_index)
	Sleep(0)
	LoadingPanelHandling
	#Else
	xpnl_Loading.BringToFront
	xpnl_Loading.SetLayoutAnimated(0,0,0,Width + 1000dip,Height + 1000dip)
	xpnl_Loading.SetVisibleAnimated(0,True)
	
	mBase.Width = Width
	mBase.Height = Height
	Sleep(0)
	xclv_main.AsView.SetLayoutAnimated(0,xclv_main.AsView.Left,xclv_main.AsView.Top,mBase.Width,mBase.Height)
	xclv_main.Base_Resize(mBase.Width,mBase.Height)
	
	'If change_widthorheight = True Then
	#If B4A
	If OversizeMode = False Then
		#End If
		For i = 0 To xclv_main.Size -1
			If g_orientation = "Horizontal" Then
				xclv_main.ResizeItem(i,mBase.Width)
			Else
				xclv_main.ResizeItem(i,mBase.Height)
			End If
		Next
	#If B4A
	End If
	#End If
	'End If
	'Sleep(0)
	If xclv_main.Size > 0 Then xclv_main.JumpToItem(current_index)
	Sleep(250)
	LoadingPanelHandling
	#End If
		#IF B4I
	m_Ignore = False
	#End if
End Sub

Private Sub LoadingPanelHandling
	If isHidding = False Then
		isHidding = True
		xpnl_Loading.SetVisibleAnimated(500,False)
		Sleep(600)
		isHidding = False
	End If
	Sleep(0)
	CheckLoadingPanelVisiblity
End Sub

Private Sub CheckLoadingPanelVisiblity
	
	Sleep(250)
	If xpnl_Loading.Visible = True And isHidding = False Then 
		isHidding = True
		xpnl_Loading.SetVisibleAnimated(500,False)
		Sleep(600)
		isHidding = False
	End If
	
End Sub

Public Sub getBase As B4XView
	Return mBase
End Sub

Public Sub AddPage(xpnl_layout As B4XView,value As Object)	
	xclv_main.Add(xpnl_layout,value)
End Sub


'Adds an page at a special position
Public Sub AddPageAt(index As Int,xpnl_layout As B4XView,value As Object)

	If index <= current_index Then
		current_index = current_index +1
	End If
	#If B4I
If g_orientation = "Horizontal" Then
		xclv_main.sv.ScrollViewOffsetX = xclv_main.sv.ScrollViewOffsetX + mBase.Width
	else If g_orientation = "Vertical" Then
		xclv_main.sv.ScrollViewOffsetY = xclv_main.sv.ScrollViewOffsetY + mBase.Height
	End If
	#Else
	'xclv_main.ScrollToItem(current_index)
	xclv_main.JumpToItem(current_index)
	#End If
	
	xclv_main.InsertAt(index,xpnl_layout,value)

End Sub

Public Sub RemovePage(index As Int)
	xclv_main.RemoveAt(index)
	If g_orientation = "Horizontal" Then
		current_index = xclv_main.FindIndexFromOffset(xclv_main.sv.ScrollViewOffsetX)
		Else
		current_index = xclv_main.FindIndexFromOffset(xclv_main.sv.ScrollViewOffsetY)
	End If
End Sub

Public Sub PreviousPage	
	If (current_index -1) > -1 Then
		'PageChangeEvent(current_index -1)
		xclv_main.ScrollToItem(current_index -1)
		PageChangedEvent(current_index -1,True)
	Else If g_Carousel = True Then
		CheckCarousel
	End If
End Sub
'jump to previous page
Public Sub PreviousPage2
	If (current_index -1) > -1 Then
		'PageChangeEvent(current_index -1)
		xclv_main.JumpToItem(current_index -1)
		PageChangedEvent(current_index -1,False)
	Else If g_Carousel = True Then
		CheckCarousel
	End If
End Sub

Public Sub NextPage
	If (current_index +1) < xclv_main.Size Then
		'PageChangeEvent(current_index +1)
		xclv_main.ScrollToItem(current_index +1)
		PageChangedEvent(current_index +1,True)
	Else If g_Carousel = True Then
		CheckCarousel
	End If
End Sub
'Jump to next page
Public Sub NextPage2
	If (current_index +1) < xclv_main.Size Then
		'PageChangeEvent(current_index +1)
		xclv_main.JumpToItem(current_index +1)
		PageChangedEvent(current_index +1,False)
	Else If g_Carousel = True Then
		CheckCarousel
	End If
End Sub

Public Sub Commit
	isLazyLoadingReady = True
	xclv_main.Refresh
End Sub

'Public Sub NextPage2
'	If (current_index +1) < xclv_main.Size Then
'		PageChangedEvent(current_index +1)
'		tmr_main.Initialize("tmr_main",1)
'		tmr_main.Enabled = True
'	End If
'End Sub
'Private Sub tmr_main_Tick
'	Dim tmp As Int = mBase.Width * current_index	
'	If xclv_main.sv.ScrollViewOffsetX = tmp Then
'		tmr_main.Enabled = False
'		Else
'		xclv_main.sv.ScrollViewOffsetX = xclv_main.sv.ScrollViewOffsetX + 5
'	End If	
'End Sub

#Region Properties
'The color of the Loading panel if Base_Resize is executed
Public Sub setLoadingPanelColor(Color As Int)
	m_LoadingPanelColor = Color
	xpnl_Loading.Color = Color
End Sub

Public Sub getLoadingPanelColor As Int
	Return m_LoadingPanelColor
End Sub

Public Sub setLazyLoadingExtraSize(ExtraSize As Int)
	m_LazyLoadingExtraSize = ExtraSize
End Sub

Public Sub getLazyLoadingExtraSize As Int
	Return m_LazyLoadingExtraSize
End Sub
'B4I and B4A only
'enabled - False the scroll is deactivated
Public Sub setScroll(enabled As Boolean)
	g_isScrollEnabled = enabled
	#IF B4I
	Dim sv As ScrollView = xclv_main.sv
	sv.ScrollEnabled = enabled
	#End If
End Sub
'Checks if the swipe/scroll is enabled or disabled
Public Sub getisScrollEnabled As Boolean
	Return g_isScrollEnabled
End Sub

Public Sub setIgnorePageChangedEvent(ignore As Boolean)
	g_ignorepagechangedevent = ignore
End Sub
Public Sub setIgnorePageChangeEvent(ignore As Boolean)
	g_ignorepagechangeevent = ignore
End Sub
'sets the current index by the value - smooth scrolls to the item
Public Sub Scroll2Value(Value As String)
	For i = 0 To xclv_main.Size -1
		If xclv_main.GetValue(i) Is String And Value = xclv_main.GetValue(i) Then
			setCurrentIndex(i)
			Exit
		End If
	Next
End Sub
'sets the current index by the value - jumps to the item
Public Sub Scroll2Value2(Value As String)
	For i = 0 To xclv_main.Size -1
		If xclv_main.GetValue(i) Is String And Value = xclv_main.GetValue(i) Then
			setCurrentIndex2(i)
			Exit
		End If
	Next
End Sub

Public Sub getCurrentIndex As Int	
		Return current_index'xclv_main.FirstVisibleIndex
End Sub

Public Sub setCurrentIndex(index As Int)
	'PageChangeEvent(index)
	xclv_main.ScrollToItem(index)
	PageChangedEvent(index,True)
End Sub
'sets the current index - jumps to the item
Public Sub setCurrentIndex2(index As Int)
	'PageChangeEvent(index)
	xclv_main.JumpToItem(index)
	PageChangedEvent(index,False)
End Sub

Public Sub getSize As Int
	Return xclv_main.Size
End Sub

Public Sub getCustomListView As CustomListView
	Return xclv_main
End Sub

Public Sub Clear
	xclv_main.Clear
	current_index = 0
End Sub
'Removes all child views from all visible pages
'Usage:
'<code>	
'xASVP_Horizontal.ResetLazyLoadingPanels
'Sleep(0)
'xASVP_Horizontal.ResetLazyloadingIndex
'xASVP_Horizontal.Commit</code>
Public Sub ResetLazyLoadingPanels
	For i = 0 To xclv_main.Size - 1
		Dim p As B4XView = xclv_main.GetPanel(i)
		'not visible
		If p.NumberOfViews > 0 Then
			p.RemoveAllViews '<--- remove the layout
		End If
	Next
End Sub

#End Region

#Region Swipe

#If B4A or B4I

Private Sub ff(x As Float,y As Float)
	isfirstmove = True
	g_ms=DateTime.Now
	g_x=X
	g_y=Y
	If g_orientation = "Horizontal" Then
	g_dv = (xclv_main.GetBase.Width)/2
	Else
	g_dv = (xclv_main.GetBase.Height)/2
	End If
	g_ad = 0
End Sub
#If B4A
Private Sub HandleTouch(Action As Int,x As Float,y As Float) As Boolean
#Else If B4I
Private Sub HandleTouch(Action As Int,x As Float,y As Float) As ResumableSub'ignore
	'Sleep(0)
#End If
	Select Action
		Case 2
			TouchBeginEvent
			ismoving = True
			If isfirstmove = False Then
				'SwipeOnEndOfPage_OnlyOnce = True
				ff(X,y)
			Else

			End If
			
			#If B4A
			If OversizeMode = True Then
				Dim clvitem1 As CLVItem = xclv_main.GetRawListItem(current_index)
				Dim tst As Double = Min(clvitem1.Offset + clvitem1.Panel.Width - mBase.Width,xclv_main.sv.ScrollViewOffsetX)
				
				If x < g_x And xclv_main.sv.ScrollViewOffsetX >= clvitem1.Offset + clvitem1.Size Then
					
				Else
					xclv_main.sv.ScrollViewOffsetX = Min(IIf(x > g_x,xclv_main.sv.ScrollViewOffsetX,tst),clvitem1.Offset + clvitem1.Size)
				End If
				
'				If x > g_x And  Then
'					
'					Else
'						
'				End If
				
				'xclv_main.sv.ScrollViewOffsetX = Min(IIf(x > g_x,xclv_main.sv.ScrollViewOffsetX,tst),clvitem1.Offset + clvitem1.Size)
			End If
			#End If
		Case 1
			TouchEndEvent
			ismoving = False
			isfirstmove = False
			#If B4A
			If OversizeMode = False Then
				#End If
				If g_orientation = "Horizontal" Then
					If ((DateTime.Now-g_ms)<300) And (Abs(X - g_x) > (1dip)) Then

						g_dv =1dip

						If X < g_x Then g_ad = 1

					End If
				Else
					If ((DateTime.Now-g_ms)<300)  And (Abs(y - g_y) > (1dip)) Then
						g_dv =1dip
				
						If y < g_y Then g_ad = 1
	
					End If
				End If

				For i = 0 To xclv_main.Size -1
					If g_orientation = "Horizontal" Then
				
						If (((i+1)*xclv_main.GetBase.Width) - xclv_main.sv.ScrollViewOffsetX) > (g_dv) Then

							If (i+g_ad) > (xclv_main.Size -1) Or xclv_main.sv.ScrollViewOffsetX <= 0 Then
								CheckCarousel
								Return False
							End If
						#If B4A or B4J
							If isNumberOneCloserToZero(g_x - x,g_y - y) = False Then
								xclv_main.ScrollToItem(current_index)
								Return True
							End If
							xclv_main.ScrollToItem(i+g_ad)
							If current_index <> (i+g_ad) Then PageChangedEvent(i+g_ad,True)
						#End If
							Return True
						End If
					Else
					
						If (((i+1)*xclv_main.GetBase.Height) - xclv_main.sv.ScrollViewOffsetY) > (g_dv) Then
						
							If (i+g_ad) > xclv_main.Size-1 Or  xclv_main.sv.ScrollViewOffsetY <= 0 Then
								CheckCarousel
								Return False
							End If
						#If B4A or B4J
							If isNumberOneCloserToZero(g_y - y,g_x - x) = False Then
								xclv_main.ScrollToItem(current_index)
								Return True
							End If
							xclv_main.ScrollToItem(i+g_ad)
							If current_index <> (i+g_ad) Then PageChangedEvent(i+g_ad,True)
						#End if
							Return True
						End If
					End If
				Next
				#If B4A
			Else
				
				Dim clvitem1 As CLVItem = xclv_main.GetRawListItem(current_index)
				'Dim tst As Double = Min(clvitem1.Offset + clvitem1.Panel.Width - mBase.Width,xclv_main.sv.ScrollViewOffsetX)
				
				If x < g_x And xclv_main.sv.ScrollViewOffsetX >= clvitem1.Offset + clvitem1.Panel.Width - mBase.Width Then
					current_index = current_index +1
					xclv_main.ScrollToItem(current_index)
				else If x > g_x And xclv_main.sv.ScrollViewOffsetX <= clvitem1.Offset And (current_index-1) >= 0 Then
					current_index = current_index -1
					xclv_main.ScrollToItem(current_index)
				End If
				
				Return True
			End If
			#End If
	End Select
	Return False
End Sub

#End If
Private Sub CheckCarousel
	If g_Carousel = True Then
		Sleep(0)
		If current_index = xclv_main.Size -1 Then
			setCurrentIndex2(0)
		Else If current_index = 0 Then
			setCurrentIndex2(xclv_main.Size -1)
		End If
	End If
End Sub
#If B4A

Private Sub xpnl_PageArea2_Touch(ViewTag As Object, Action As Int, X As Float, y As Float, MotionEvent As Object) As Boolean
	If g_isScrollEnabled = False Then Return True
	Return HandleTouch(Action,x,y)
End Sub

#Else If B4I

Private Sub uigesture_longpress(state As Int,numtouch As Int, Numtaps As Int, x As Float, y As Float, obj As Object)

	If g_isScrollEnabled = False Then Return
	If state = 1 Then'tmp.STATE_Begin Then
		HandleTouch(2,x,y)
		'TouchEndEvent
	End If

End Sub

Private Sub uigesture_pan(state As Int,x As Float, y As Float, obj As Object)


	If g_isScrollEnabled = False Then Return
	'Log("att.X: " & att.X)
	Select state
		Case 2 'STATE_Changed
			'TouchBeginEvent
			HandleTouch(2,x,y)
		Case 3 'STATE_End
			HandleTouch(1,x,y)
	End Select
	
End Sub


'Private Sub tmp_longpress(state As Int, att As LongPress_Attributes)
'	If g_isScrollEnabled = False Then Return
'	If state = 1 Then'tmp.STATE_Begin Then
'		HandleTouch(2,att.X,att.Y)
'		'TouchEndEvent
'	End If
'End Sub
'
'Private Sub tmp_pan(state As Int, att As Pan_Attributes)
'	If g_isScrollEnabled = False Then Return
'	'Log("att.X: " & att.X)
'	Select state
'		Case 2 'STATE_Changed
'			'TouchBeginEvent
'			HandleTouch(2,att.X,att.Y)
'		Case 3 'STATE_End
'			HandleTouch(1,att.X,att.Y)
'	End Select
'End Sub

#Else If B4J
Private Sub et_Filter (EventData As Event)
	If g_isScrollEnabled = True Then
		Dim jo As JavaObject = EventData
		Dim code As String = jo.RunMethod("getCode", Null)
		Dim EventType As String = jo.RunMethod("getEventType", Null)

'	If EventType = "KEY_PRESSED" Then       
'		Log("KEY_PRESSED")  
'		Log("Code: " & code) 
		If EventType = "KEY_RELEASED" Then
			'Log("Code: " & code)
			If g_orientation = "Horizontal" Then
				If code = "RIGHT" Then
					NextPage
				Else If code = "LEFT" Then
					PreviousPage
				End If
			Else
				If code = "DOWN" Then
					NextPage
				Else If code = "UP" Then
					PreviousPage
				End If
			End If
		End If
	End If
End Sub

#End If

#End Region

#Region Events

Private Sub xclv_main_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	#IF B4I
	If m_Ignore = False Then
	If FirstIndex < current_index Then
		PageChangedEvent(LastIndex,False)
	Else
		PageChangedEvent(FirstIndex,False)
	End If
	End If
	#End If
	
	If m_LazyLoading = False Or m_IgnoreLazyLoading = True Then Return
	
	'Log(lazyloading_index)
	'Log(xclv_main.FindIndexFromOffset(IIf(g_orientation = "Vertical",xclv_main.sv.ScrollViewOffsety,xclv_main.sv.ScrollViewOffsetx)))
	
	'Log(IIf(g_orientation = "Vertical",xclv_main.sv.ScrollViewOffsety,xclv_main.sv.ScrollViewOffsetx).As(Int))
	'Log(IIf(g_orientation = "Vertical",mBase.Height,mBase.Width) * xclv_main.FindIndexFromOffset(IIf(g_orientation = "Vertical",xclv_main.sv.ScrollViewOffsety,xclv_main.sv.ScrollViewOffsetx)).As(Int))
	
	'Log(xclv_main.FindIndexFromOffset(IIf(g_orientation = "Vertical",xclv_main.sv.ScrollViewOffsety,xclv_main.sv.ScrollViewOffsetx)).As(Int))
	
	If lazyloading_index = current_index And xclv_main.GetPanel(current_index).NumberOfViews = 0 Then lazyloading_index = -1
	
	If lazyloading_index <> current_index Then
	'If lazyloading_index <> xclv_main.FindIndexFromOffset(IIf(g_orientation = "Vertical",xclv_main.sv.ScrollViewOffsety,xclv_main.sv.ScrollViewOffsetx)) And IIf(g_orientation = "Vertical",xclv_main.sv.ScrollViewOffsety,xclv_main.sv.ScrollViewOffsetx).As(Int) = IIf(g_orientation = "Vertical",mBase.Height,mBase.Width) * xclv_main.FindIndexFromOffset(IIf(g_orientation = "Vertical",xclv_main.sv.ScrollViewOffsety,xclv_main.sv.ScrollViewOffsetx)).As(Int) Then
	If isLazyLoadingReady = True Then	lazyloading_index = xclv_main.FindIndexFromOffset(IIf(g_orientation = "Vertical",xclv_main.sv.ScrollViewOffsety,xclv_main.sv.ScrollViewOffsetx))
	For i = 0 To xclv_main.Size - 1
		Dim p As B4XView = xclv_main.GetPanel(i)
		If i > FirstIndex - m_LazyLoadingExtraSize And i < LastIndex + m_LazyLoadingExtraSize Then
			'visible+
			If p.NumberOfViews = 0 Then
				LazyLoadingAddContent(p,xclv_main.GetValue(i))
			End If
		Else
			'not visible
			If p.NumberOfViews > 0 Then
				p.RemoveAllViews '<--- remove the layout
			End If
		End If
	Next
	End If
End Sub

Public Sub ResetLazyloadingIndex
	lazyloading_index = -1
End Sub
'If True, the Lazy Loading event is not triggered
Public Sub setIgnoreLazyLoading(Ignore As Boolean)
	m_IgnoreLazyLoading = Ignore
End Sub

Private Sub xclv_main_ScrollChanged (Offset As Int)
	
'	#If B4I
'	
'	If m_Offset > Offset Then
'		PageChangedEvent(xclv_main.LastVisibleIndex,False)
'	Else
'		PageChangedEvent(xclv_main.FirstVisibleIndex,False)
'	End If
'	
'	#Else
	If xclv_main.FindIndexFromOffset(Offset) <> current_index And Offset = IIf(g_orientation = "Vertical",mBase.Height,mBase.Width) * xclv_main.FindIndexFromOffset(Offset) Then
		PageChangedEvent(xclv_main.FindIndexFromOffset(Offset),False)
	End If
	'#End If
	
	
	If xui.SubExists(mCallBack, mEventName & "_ScrollChanged", 1) Then
		CallSub2(mCallBack, mEventName & "_ScrollChanged",Offset)
	End If
End Sub

Private Sub xclv_main_ReachEnd
	If xui.SubExists(mCallBack, mEventName & "_ReachEnd", 0) Then
		CallSub(mCallBack, mEventName & "_ReachEnd")
	End If
End Sub

'Private Sub PageChangeEvent(index As Int)
'	If current_index = index Then Return
'	current_index = index
'	If g_ignorepagechangeevent = False And xui.SubExists(mCallBack, mEventName & "_PageChange", 1) Then
'		CallSub2(mCallBack, mEventName & "_PageChange",index)
'	End If
'End Sub

Private Sub LazyLoadingAddContent(Parent As B4XView,Value As Object)
	If isLazyLoadingReady = True And xui.SubExists(mCallBack, mEventName & "_LazyLoadingAddContent", 2) Then	
		CallSub3(mCallBack, mEventName & "_LazyLoadingAddContent",Parent,Value)
	End If
End Sub

Private Sub PageChangedEvent(index As Int,delayed As Boolean)
	If current_index = index Then Return
	current_index = index
	If g_ignorepagechangeevent = False And xui.SubExists(mCallBack, mEventName & "_PageChange", 1) Then
		CallSub2(mCallBack, mEventName & "_PageChange",index)
	End If
	
	If delayed = True Then Sleep(300)
	
	If g_ignorepagechangedevent = False And xui.SubExists(mCallBack, mEventName & "_PageChanged", 1) Then
		CallSub2(mCallBack, mEventName & "_PageChanged",index)
	End If
End Sub
#IF B4A or B4I
Private Sub TouchBeginEvent
	If ismoving = False Then
	If xui.SubExists(mCallBack, mEventName & "_TouchBegin", 0) Then
		CallSub(mCallBack, mEventName & "_TouchBegin")
	End If
	End If
End Sub

Private Sub TouchEndEvent
	If xui.SubExists(mCallBack, mEventName & "_TouchEnd", 0) Then
		CallSub(mCallBack, mEventName & "_TouchEnd")
	End If
End Sub
#End If

Private Sub xclv_main_ItemClick (Index As Int, Value As Object)
	If xui.SubExists(mCallBack, mEventName & "_PageClick", 2) Then
		CallSub3(mCallBack, mEventName & "_PageClick",Index,Value)
	End If
End Sub

'Private Sub SwipeOnEndOfPage
'	SwipeOnEndOfPage_OnlyOnce = False
'	If xui.SubExists(mCallBack, mEventName & "_SwipeOnEndOfPage", 0) Then
'		CallSub(mCallBack, mEventName & "_SwipeOnEndOfPage")
'	End If
'End Sub

Private Sub isNumberOneCloserToZero (numberOne As Int, numberTwo As Int) As Boolean 'ignore
	Return (Abs(numberOne) >= Abs(numberTwo))
End Sub

#End Region


#Region GestureRecongnizer

#If OBJC
/////////TAP//////////

- (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldRecognizeSimultaneouslyWithGestureRecognizer:(UIGestureRecognizer *)otherGestureRecognizer
{
     return TRUE;
}

-(void)grTap: (int)numtaps :(int)numtouch :(UIView*)v
{
UITapGestureRecognizer *Tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTap:)];
Tap.delegate=self;
[Tap setNumberOfTapsRequired:numtaps];
[Tap setNumberOfTouchesRequired:numtouch];


[v addGestureRecognizer:Tap];
}

- (void)handleTap:(UITapGestureRecognizer *)gestureRecognizer {  

float x= [gestureRecognizer locationInView:(self._mview).object].x;
float y= [gestureRecognizer locationInView:(self._mview).object].y;


	int st =gestureRecognizer.state;
    int numtouch =gestureRecognizer.numberOfTouchesRequired;
    int numtap =gestureRecognizer.numberOfTapsRequired;
    [self.bi raiseEvent:nil event:@"uigesture_tap::::::" params:@[@((int)st),@((int)numtap),@((int)numtouch),@((float)x),@((float)y),(gestureRecognizer)]];

  }  


////////////PINCH/////////////

-(void)grPinch :(UIView*)v
{
UIPinchGestureRecognizer *pinch = [[UIPinchGestureRecognizer alloc] initWithTarget:self  action:@selector(handlePinch:)];
 pinch.delegate=self;
 [v addGestureRecognizer:pinch];

}

- (void)handlePinch:(UIPinchGestureRecognizer *)gestureRecognizer 
{  

float x= [gestureRecognizer locationInView:(self._mview).object].x;
float y= [gestureRecognizer locationInView:(self._mview).object].y;

	float sc=gestureRecognizer.scale;
	float vl=gestureRecognizer.velocity;
	int st =gestureRecognizer.state;
    [self.bi raiseEvent:nil event:@"uigesture_pinch::::::" params:@[@((float)sc),@((float)vl),@((int)st),@((float)x),@((float)y),(gestureRecognizer)]];


  }  
  

  
  
//////// ROTATION /////////////

-(void)grRotation :(UIView*)v
{
UIRotationGestureRecognizer *Rotation = [[UIRotationGestureRecognizer alloc] initWithTarget:self  action:@selector(handleRotation:)];
 Rotation.delegate=self;
 [v addGestureRecognizer:Rotation];

}

- (void)handleRotation:(UIRotationGestureRecognizer *)gestureRecognizer 
{  

float x= [gestureRecognizer locationInView:(self._mview).object].x;
float y= [gestureRecognizer locationInView:(self._mview).object].y;

	float rt=gestureRecognizer.rotation;
	float vl=gestureRecognizer.velocity;
	int st =gestureRecognizer.state;
    [self.bi raiseEvent:nil event:@"uigesture_rotation::::::" params:@[@((float)rt),@((float)vl),@((int)st),@((float)x),@((float)y),(gestureRecognizer)]];


  }  
  
  
///////////// SWIPE //////////////

-(void)grSwipe :(UIView*)v :(int)numtouch :(int)dir
{
UISwipeGestureRecognizer *swipe = [[UISwipeGestureRecognizer alloc] initWithTarget:self  action:@selector(handleSwipe:)];
 
// if (dir==1)
// {
  [swipe setDirection:dir];

// }
 
 
 [swipe setNumberOfTouchesRequired:numtouch];
  swipe.delegate=self;
 [v addGestureRecognizer:swipe];

}


- (void)handleSwipe:(UISwipeGestureRecognizer *)gestureRecognizer {  

float x= [gestureRecognizer locationInView:(self._mview).object].x;
float y= [gestureRecognizer locationInView:(self._mview).object].y;

	int st =gestureRecognizer.state;
	int dir=gestureRecognizer.direction;

    [self.bi raiseEvent:nil event:@"uigesture_swipe:::::" params:@[@((int)st),@((int)dir),@((float)x),@((float)y),(gestureRecognizer)]];

  }  

/////////// PAN ///////////

-(void)grPan :(UIView*)v :(int)mintouch :(int)maxtouch
{
UIPanGestureRecognizer *pan = [[UIPanGestureRecognizer alloc] initWithTarget:self  action:@selector(handlePan:)];
 
 [pan setMaximumNumberOfTouches:maxtouch];
 [pan setMinimumNumberOfTouches:mintouch];
pan.delegate=self;
 [v addGestureRecognizer:pan];

}

- (void)handlePan:(UIPanGestureRecognizer *)gestureRecognizer {  

	int st =gestureRecognizer.state;
float x= [gestureRecognizer locationInView:(self._mview).object].x;
float y= [gestureRecognizer locationInView:(self._mview).object].y;

    [self.bi raiseEvent:nil event:@"uigesture_pan::::" params:@[@((int)st),@((float)x),@((float)y),(gestureRecognizer)]];

  }  

///////////// SCREEN EDGE ///////////

-(void)grScreenEdge :(UIView*)v :(int)dir 
{
UIScreenEdgePanGestureRecognizer *panEdge = [[UIScreenEdgePanGestureRecognizer alloc] initWithTarget:self  action:@selector(handlePanEdge:)];
 
 [panEdge setEdges:dir];
 [v addGestureRecognizer:panEdge];

}

- (void)handlePanEdge:(UIScreenEdgePanGestureRecognizer *)gestureRecognizer {  

float x= [gestureRecognizer locationInView:(self._mview).object].x;
float y= [gestureRecognizer locationInView:(self._mview).object].y;

	int st =gestureRecognizer.state;
	int ed =[gestureRecognizer edges];
    [self.bi raiseEvent:nil event:@"uigesture_screenedgepan:::::" params:@[@((int)st),@((int)ed),@((float)x),@((float)y),(gestureRecognizer)]];

  }  
  
  
  
///////////LONG PRESS////////


-(void)grLongPress: (int)numtaps :(int)numtouch :(float)interval :(UIView*)v
{
UILongPressGestureRecognizer *longpress = [[UILongPressGestureRecognizer alloc] initWithTarget:self action:@selector(handleLongPress:)];

[longpress setNumberOfTapsRequired:numtaps];
[longpress setNumberOfTouchesRequired:numtouch];
[longpress setMinimumPressDuration:interval];
longpress.delegate=self;
[v addGestureRecognizer:longpress];
}

- (void)handleLongPress:(UILongPressGestureRecognizer *)gestureRecognizer {  

float x= [gestureRecognizer locationInView:(self._mview).object].x;
float y= [gestureRecognizer locationInView:(self._mview).object].y;

	int st =gestureRecognizer.state;
	int numtouch =gestureRecognizer.numberOfTouchesRequired;
    int numtap =gestureRecognizer.numberOfTapsRequired;
    [self.bi raiseEvent:nil event:@"uigesture_longpress::::::" params:@[@((int)st),@((int)numtouch),@((int)numtap),@((float)x),@((float)y),(gestureRecognizer)]];
  }  

#End If

#End Region
